#!/usr/bin/perl

#┌─────────────────────────────────
#│  YY-BOARD : icoreg.cgi 2019/11/14 Ver:2.0
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────
# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# 処理分岐
if ($in{mode} eq "icoreg") { icoreg(); }
if ($in{mode} eq 'icodel') { icodel(); }
if ($in{mode} eq 'icoedit') { icoedit(); }
if ($in{mode} eq 'gate_form') { gate_form(); }
if ($in{mode} eq 'note')  { note_page(); }
icon_list();

#-----------------------------------------------------------
#  アイコンリスト画面
#-----------------------------------------------------------
sub icon_list {
	# アイコン削除
	if ($in{dele}) { dele_conf(); }
	if ($in{edit}) { icoedit(); }

	# ページ数定義
	my $pg = $in{pg} || 0;

	# 表示データ認識
	my ($i,@log);
	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<IN>) {

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_icon});

		push(@log,$_);
	}
	close(IN);

	# ページ繰越ボタン作成
	my $pgbtn = make_btn($i,$pg);

	# クッキー取得
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/iconreg.html") or error("open err: iconreg.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon2" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!page_btn!/$pgbtn/g;
	$tmpl =~ s/!reg-name!/$cook[0]/g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/!pg!/$in{pg} eq '' ? '0' : $in{pg}/ge;
	$tmpl =~ s/!sub!//g;
	$tmpl =~ s/!reno!//g;
	$tmpl =~ s/!reg-eml!/$cook[1]/g;
	$tmpl =~ s/!reg-url!/$cook[2]/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : error("テンプレートが不正です");

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# 表示データ展開
	foreach (@log) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);
		$eml = qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon"></a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon" alt="$no$ex"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		my $clip;
		# アイコンあり
		if ($ex) {
			if ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{iconurl}/$no-s$ex") {
					$op = qq|src="$cf{iconurl}/$no-s$ex"|;
				} else {
					($w,$h) = ico_resize($w,$h);
					$op = qq|src="$cf{iconurl}/$no$ex" width="$w" height="$h"|;
				}

			# 画像情報
			my $picinf;
			if ($ex eq ".gif") {
				$picinf = "GIF";
			}
			if ($ex eq ".jpg") {
				$picinf = "JPEG";
			}
			if ($ex eq ".png") {
				$picinf = "PNG";
			}

				my $size = get_size("$cf{iconurl}/$no$ex");
				$clip .= qq|<img $op border="0" hspace="18" alt="">( w$w×h$h <b style="color:#FF9966">$size</b>　<b style="color:#00afcc">$picinf</b> )|;
			}
		}

		if ($icotype ==1) { 
			$icotype = "$nam 様専用"; 
		} else { 
			$icotype = "共用アイコン";
		}

		# アイコンリスト書き出し
		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!art_sub!/$sub ($icotype)/g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!email!/$eml/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/<!-- regicon -->/$clip/g;
		$tmp =~ s/!comment!/$com/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  繰越ボタン作成
#-----------------------------------------------------------
sub make_btn {
	my ($i,$pg,$param) = @_;

	# ページ繰越数定義
	$cf{max_icon} ||= 10;
	my $next = $pg + $cf{max_icon};
	my $back = $pg - $cf{max_icon};

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{icoreg_cgi}?pg=$y$param">$x</a></li>!);
			}
			$x++;
			$y += $cf{max_icon};
			$z -= $cf{max_icon};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{icoreg_cgi}?pg=$back$param">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{icoreg_cgi}?pg=$next$param">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	# クッキー取得
	$ENV{HTTP_COOKIE} =~ /$cf{cookie_id}=(.+);?/;
	my $cookie = $1;

	# URLデコード
	my @cook;
	foreach ( split(/<>/,$cookie) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  アイコン受付処理
#-----------------------------------------------------------
sub icoreg {

	# 不要改行カット
	$in{name} =~ s/<br>//g;
	$in{pwd}  =~ s/<br>//g;
	$in{captcha} =~ s/<br>//g;
	$in{comment} =~ s/(<br>)+$//g;

	# 入力値調整
	if ($in{url} eq 'http://') { $in{url} = ''; }

	# フォーム内容をチェック
	my $err;
	if ($in{name} eq "") { $err .= "登録者の名前が入力されていません<br>"; }
	if ($in{sub} eq "") { $err .= "アイコンの名称が入力されていません<br>"; }
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/) {
		$err .= "Ｅメールの入力内容が不正です<br>";
	}
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "参照先URLの入力内容が不正です<br>";
	}

	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	my @ico = <IN>;
	close(IN);

	foreach(@ico){
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);
		if($sub eq $in{sub}) {$err .= "そのアイコンの名称は、すでに登録されています<br>";}
	}

	if ($err) { error($err); }

	# 時間取得
	$ENV{TZ} = "JST-9";
	my $now = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($now))[1..6];
	my @week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	# ホスト取得
	my ($host,$addr) = get_host();

	# 時間取得
	my ($date,$time) = get_time();

	open(DAT,"+< $cf{iconfile}") or error("open err: $cf{iconfile}");
	eval "flock(DAT, 2);";
	my $log = <DAT>;
	my ($no,$nam,$com,$ex) = (split(/<>/, $log))[0,2,4,9];

	# アイコン登録No採番
	$no++;

	# アイコン添付処理
	my ($ext,$w,$h) = ico_upload($no);

	# 削除キー暗号化
	my $crypt = encrypt($in{pwd}) if ($in{pwd} ne "");

	# 最大登録アイコン数処理
	my $i = 0;
	my @log;
	seek(DAT, 0, 0);
	while (<DAT>) {
		$i++;
		my ($no,$dat,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$only) = split(/<>/);

		if ($i <= $cf{max} - 1) {
			push(@log,$_);
		}
	}

	# 新記事
	unshift(@log,"$no<>$date<>$in{name}<>$in{sub}<>$in{email}<>$in{comment}<>$in{url}<>$host<>$crypt<>$ext<>$w<>$h<>$in{icontype}<>\n");

	# 更新
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 完了画面
	message("アイコンを登録しました。");
}

#-----------------------------------------------------------
#  アイコンアップロード
#-----------------------------------------------------------
sub ico_upload {
	my $no = shift;

	# サムネイル機能
	require './lib/thumb.pl' if ($cf{thumbnail});

	# 拡張子取得
	my $ext = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("拡張子不明");
	$ext =~ tr/A-Z/a-z/;
	if ($ext eq '.jpeg') { $ext = '.jpg'; }
	if ($ext eq '.text') { $ext = '.txt'; }

	# ファイルチェック
	check_upl($ext);

	# 添付ファイル定義
	my $upfile = "$cf{iconurl}/$no$ext";

	# アップロード書き込み
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666, $upfile);

	# 画像サイズ取得
	my ($flg,$w,$h);
	if ($ext eq ".jpg") { ($w,$h) = &j_size($upfile); $flg++; }
	elsif ($ext eq ".gif") { ($w,$h) = &g_size($upfile); $flg++; }
	elsif ($ext eq ".png") { ($w,$h) = &p_size($upfile); $flg++; }

	# サムネイル化
	if ($flg && $cf{thumbnail}) {
		($w,$h) = &resize($w,$h);
		my $thumb = "$cf{iconurl}/$no-s$ext";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# 結果を返す
	return ($ext,$w,$h);
}

#-----------------------------------------------------------
#  JPEGサイズ認識
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFサイズ認識
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGサイズ認識
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  アイコン削除
#-----------------------------------------------------------
sub icodel {
	# 入力チェック
	$in{no} =~ s/\D//g;
	if ($in{no} eq '' || $in{pwd} eq '') {
		error("アイコン登録Noまたは削除キーが入力モレです");
	}

	my ($flg,$crypt,$ext,@log);
	open(DAT,"+< $cf{iconfile}") or error("open err: $cf{iconfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$dat,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex) = split(/<>/);

		if ($in{no} == $no) {
			$flg++;
			$crypt = $pw;
			$ext = $ex;
			next;
		}
		push(@log,$_);
	}

	if (!$flg || $crypt eq '') {
		close(DAT);
		error("削除キーが設定されていないか、該当リストが見当たりません");
	}

	# 削除キーを照合
	if (decrypt($in{pwd}, $crypt) != 1) {
		close(DAT);
		error("認証できません");
	}

	# ログを更新
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# アイコン削除
	if ($ext) {
		unlink("$cf{iconurl}/$in{no}$ext");
		unlink("$cf{iconurl}/$in{no}-s$ext") if (-f "$cf{iconurl}/$in{no}-s$ext");
	}

	message("アイコンを削除しました");
}

#-----------------------------------------------------------
#  アイコン削除確認
#-----------------------------------------------------------
sub dele_conf {
	my %log;
	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<IN>) {
		my ($no,$dat,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h) = split(/<>/);
		if ($in{dele} == $no) {
			$log{flg}++;
			$log{num}  = $no;
			$log{sub}  = $sub;
			$log{date} = $dat;
			$log{name} = $nam;
			$log{ex} = $ex;
			$log{w} = $w;
			$log{h} = $h;
			last;
		}
	}
	close(IN);
	
	if (!$log{flg}) { error("該当アイコンが見つかりません"); }
	
	open(IN,"$cf{tmpldir}/icon_pwd.html") or error("open err: icon_pwd.html");
	my $tmpl = join('', <IN>);
	close(IN);

	my $clip;
	my $size = get_size("$cf{iconurl}/$log{num}$log{ex}");
		$clip .= qq|<img src="$cf{iconurl}/$log{num}$log{ex}" width="$log{w}" height="$log{h}" border="0" hspace="18" alt="">|;
	
	my $pg = $in{pg} || 0;
	#$tmpl =~ s/!(\w+_\w+)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!(sub|name|date|num|ex)!/$log{$1}/g;
	$tmpl =~ s/!pg!/$pg/g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s/<!-- regicon -->/$clip/g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  アイコン編集
#-----------------------------------------------------------
sub icoedit {
	# チェック
	if ($in{edit} =~ /\D/) { error('不正な要求です'); }

	# 修正フォーム
	if (!$in{pwd}) { gate_form(); }

	# 実行
	if ($in{job} eq "edit") {

	# フォーム内容をチェック
	my $err;
	if ($in{name} eq "") { $err .= "登録者の名前が入力されていません<br>"; }
	if ($in{sub} eq "") { $err .= "アイコンの名称が入力されていません<br>"; }
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/) {
		$err .= "Ｅメールの入力内容が不正です<br>";
	}
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "参照先URLの入力内容が不正です<br>";
	}
	if ($err) { error($err); }

	# 差し替え
	my ($flg, $ext2,$w2,$h2, @data);
	open(DAT,"+< $cf{iconfile}") or error("open err: $cf{iconfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);

		if ($in{edit} == $no) {
		         $flg = 1;

			# アップロード
			if ($in{upfile}) {
				($ext2,$w2,$h2) = ico_upload($no);
			}

			# 画像削除
			if ($in{imgdel}) {
				unlink("$cf{iconurl}/$no$ex");
				$ex = $w = $h = '';
			}

			# 添付アップロードの場合
			if ($ext2) {
				# 拡張子変更の場合旧ファイル削除
				if ($ex && $ext2 ne $ex) {
					unlink("$cf{iconurl}/$no$ex");
				}
				# 新添付ファイル情報
				($ex,$w,$h) = ($ext2,$w2,$h2);
			}

		         $_ = "$no<>$date<>$in{name}<>$in{sub}<>$in{email}<>$in{comment}<>$in{url}<>$hos<>$pw<>$ex<>$w<>$h<>$in{icontype}<>\n";
	}
	push(@data,$_);
	}

	if ($flg != 1) {
		close(DAT);
		error("不正な処理です");
	}

	# 更新
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 完了メッセージ
	message("アイコンの修正を完了しました");
	}

	# アイコンファイル抽出
	my ($flg, @edit);
	open(DAT,"+< $cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<DAT>) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);

		if ($in{edit} == $no) {

			# 登録キーなし
			if ($pw eq '') {
				$flg = 2;
			} elsif

			# 登録キー一致
			(decrypt($in{pwd}, $pw) == 1) {
				$flg = 1;
				@edit = ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype);

			# 登録キー不一致
			} else {
				$flg = 3;
			}
			last;
		}
	}
	close(IN);

	if (!$flg) {
		close(DAT);
		error("アイコンが見当たりません");
	} elsif ($flg == 2) {
		close(DAT);
		error("このアイコンには登録キーが設定されていません");
	} elsif ($flg == 3) {
		close(DAT);
		error("登録キーが違います");
	}

	# 改行復元
	my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);
	$com =~ s/<br>/\n/g;
	#$url ||= 'http://';

	# 添付ファイル
	my $attach;
	if ($ex) {
		$attach .= qq|&nbsp;[ <a href="$cf{iconurl}/$no$ex" target="_blank">Attached file</a> ]\n|;
		$attach .= qq|<input type="checkbox" name="imgdel" id="checkbox" value="1"><label for="checkbox">削除</label>\n|;
	}

	# 修正フォーム
	open(IN,"$cf{tmpldir}/ico_edit.html") or &error("open err: edit.html");
	my $tmpl = join('', <IN>);
	close(IN);

	if ($icotype eq "1") {
		$tmpl =~ s|<!-- checkbox -->|<input type="checkbox" name="icontype" value="1" checked="checked" />|g;
	} else {
		$tmpl =~ s|<!-- checkbox -->|<input type="checkbox" name="icontype" value="1"  />|g;
	}

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/!pg!/$in{pg} eq '' ? '0' : $in{pg}/ge;
	$tmpl =~ s/!edit!/$in{edit}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!pwd!/$pw/g;
	$tmpl =~ s/!name!/$nam/;
	$tmpl =~ s/!email!/$eml/;
	$tmpl =~ s/!url!/$url/;
	$tmpl =~ s/!sub!/$sub/;
	$tmpl =~ s/!comment!/$com/;
	$tmpl =~ s/<!-- attach -->/$attach/g;

	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  暗証キー入力
#-----------------------------------------------------------
sub gate_form {

	# 記事
	my ($name,$pwd);
	open(DAT,"+< $cf{iconfile}") or error("open err: $cf{iconfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);

		if ($in{edit} == $no) {
			$name = $name;
			$pwd = $pw;
			last;
		}
	}
	close(DAT);

	# パスワード未設定
	error("このアイコンは登録キー未設定のため編集できません") if ($pwd eq '');

	my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$icotype) = split(/<>/);
		$eml = qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon"></a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon" alt="$no$ex"></a>|;
		$com = auto_link($com) if ($cf{autolink});

	my $clip;
	my $size = get_size("$cf{iconurl}/$no$ex");
		$clip .= qq|<img src="$cf{iconurl}/$no$ex" width="$w" height="$h" border="0" hspace="18" alt="">|;

	open(IN,"$cf{tmpldir}/ico_gate.html") or &error("open err: ico_gate.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!edit!/$in{edit}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$nam/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!comment!/$com/g;
	$tmpl =~ s/!home!/home_link($url)/e;
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/!pg!/$in{pg} eq '' ? '0' : $in{pg}/ge;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/<!-- regicon -->/$clip/;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon2" />|g;

	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  留意事項表示
#-----------------------------------------------------------
sub note_page {
	# 許可拡張子（表示用）
	my $ext = ext_file();
	
	open(IN,"$cf{tmpldir}/iconote.html") or error("open err: iconote.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!file!/$ext/g;
	$tmpl =~ s/!max_w!/$cf{ico_max_img_w}/g;
	$tmpl =~ s/!max_h!/$cf{ico_max_img_h}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	
	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;
	
	open(IN,"$cf{tmpldir}/ico_msg.html") or error("open err: ico_msg.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!message!/$msg/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	
	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  時間取得
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 日時のフォーマット
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  ホスト名取得
#-----------------------------------------------------------
sub get_host {
	# IP&ホスト取得
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IPチェック
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		error("アクセスを許可されていません");

	# ホストチェック
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			error("アクセスを許可されていません");
		}
	}
	$host ||= $addr;
	return ($host, $addr);
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;
	
	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
	- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
	- <a href="http://drc3.news-site.net/script1" target="_top">Edited by Hamel</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  ファイルチェック
#-----------------------------------------------------------
sub check_upl {
	my ($ext) = @_;

	# mimeタイプ
	my $mime = $cgi->param_mime('upfile');

	my $flg;
	if ($cf{ok_gif}) {
		if ($mime =~ /^image\/gif$/i and $ext eq '.gif') { $flg++; }
	}
	if (!$flg and $cf{ok_jpeg}) {
		if ($mime =~ /^image\/p?jpe?g$/i and $ext eq '.jpg') { $flg++; }
	}
	if (!$flg and $cf{ok_png}) {
		if ($mime =~ /^image\/(x-)?png$/i and $ext eq '.png') { $flg++; }
	}
	if (!$flg and $cf{ok_pdf}) {
		if ($mime =~ /^application\/pdf$/i and $ext eq '.pdf') { $flg++; }
	}
	if (!$flg and $cf{ok_zip}) {
		if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ext eq '.zip') { $flg++; }
	}
	if (!$flg and $cf{ok_text}) {
		if ($mime =~ /^text\/plain$/i and $ext =~ /^\.te?xt$/) { $flg++; }
	}
	if (!$flg and $cf{ok_word}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ext eq '.doc') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ext eq '.docx') { $flg++; }
	}
	if (!$flg and $cf{ok_excel}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ext eq '.xls') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ext eq '.xlsx') { $flg++; }
	}
	if (!$flg and $cf{ok_ppt}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ext eq '.ppt') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ext eq '.pptx') { $flg++; }
	}

	if (!$flg) { error('このファイルは取り扱いできません'); }
}

#-----------------------------------------------------------
#  取り扱いファイル
#-----------------------------------------------------------
sub ext_file {
	my $ext;
	foreach ( keys %cf ) {
		next if ($_ !~ /^ok_(\w+)/);
		my $file = $1;
		next if (!$cf{$_});
		
		$file =~ tr/a-z/A-Z/;
		$ext .= "$file, ";
	}
	$ext =~ s/, $//;
	
	return $ext;
}

#-----------------------------------------------------------
#  crypt暗号
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in, $salt) || crypt ($in, '$1$' . $salt);
}

#-----------------------------------------------------------
#  crypt照合
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

