#!/usr/bin/perl

#┌─────────────────────────────────
#│ YY-BOARD : yybbs.cgi - 2019/11/04
#│ copyright (c) KentWeb, 1997-2019
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  YY-BOARD v10.1 PLUS 2019/11/14
#│  Edited by Hamel(TRANSFORM) Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────
# 仙人の里改造版
#┌─────────────────────────────────
#│  YY-BOARD v10.12.s0 Black 2021/01/17
#│  Adapted by Sennin
#│  配布場所 http://sennin.o.oo7.jp/
#│  ＨＰ http://www.senninnosato.net/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;

# 設定ファイル認識
require "./init.cgi";
my %cf = set_init();

# データ受理
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('容量オーバー') if ($cgi->truncated);
my %in = parse_form($cgi);

# アクセス制限
passwd(%in) if ($cf{enter_pwd} ne '');

# 処理分岐
if ($in{mode} eq 'find') { find_data(); }
if ($in{mode} eq 'expound') { expound_page(); }
if ($in{mode} eq 'note') { note_page(); }
if ($in{mode} eq 'icon') { icon_page(); }
if ($in{mode} eq 'past') { past_log(); }
if ($in{mode} eq 'form') { form_page(); }
if ($in{mode} eq 'border') { border_page(); }
if ($in{mode} eq 'p_form') { p_form(); }
if ($in{mode} eq 'album') { album(); }
if ($in{mode} eq 'album_past') { album_past(); }
bbs_list();

#-----------------------------------------------------------
#  記事表示部
#-----------------------------------------------------------
sub bbs_list {
	# アラーム数定義
	my $alarm = int ( $cf{m_max} * 0.9 );

	# 返信フォーム
	read_log($in{res},'res') if ($in{res} > 0);
	
	# 記事展開
	my ($i,@log,%res,%nam,%sub,%dat,%com,%url,%eml,%col,%ico,%color2,%rno,%upd,%ext,%imw,%imh,%tube);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/);
		
		++$i if (!$reno);
		next if ($i < $in{pg} + 1);
		next if ($i > $in{pg} + $cf{pg_max});
		
		# 親記事
		if (!$reno) {
			push(@log,$no);
			$rno{$no} = 0;
			$upd{$no} = "$date<br />$name";
			
		# レス記事
		} else {
			$res{$reno} .= "$no,";
			$rno{$reno}++;
			$upd{$reno} = "$date<br />$name";
		}
		# リンク（スレッドのとき）
		if (!$in{bbs}) {
			$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="home"></a>|;
			$com = auto_link($com) if ($cf{autolink});
			$in{bbs} = 0;
		}

		# ハッシュ化
		$nam{$no} = $name;
		$sub{$no} = $sub;
		$dat{$no} = $date;
		$com{$no} = $com;
		$col{$no} = $col;
		$url{$no} = $url;
		$eml{$no} = $eml;
		$ico{$no} = $ico;
		$color2{$no} = $color2;
		$tube{$no} = $tube;

		if ($ext) {
			if ($cf{img_check} && $chk eq '0') {
				$ext{$no} = "hide";
			} else {
				$ext{$no} = $ext;
				$imw{$no} = $w;
				$imh{$no} = $h;
			}
		}
}
	close(IN);

	# 繰越ボタン作成
	my $page_btn = make_pgbtn($i,$in{pg},"&amp;bbs=$in{bbs}");

	# クッキー取得
	my @cook = get_cookie($cf{cookie_id});
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[3] eq "") { $cook[3] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[5] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	# アイコン
	my @icon;
	foreach (@{$cf{icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@icon,$ico);
	}

	# アイコンプルダウン
	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($cook[4] eq $icon[$_]) {
			$op_icon .= qq|<option value="$icon[$_]" selected>$nam\n|;
		} else {
			$op_icon .= qq|<option value="$icon[$_]">$nam\n|;
		}
	}
        #セレクトアイコン
	my ($selecticon,$icon);
        	if ($cook[4] eq '') {
			$selecticon = $icon[0];
        	} else {
			$selecticon = $cook[4];
        	}

	# カウンタ
	my $counter = bbs_count() if ($cf{counter});
	
	# home or logoff
	my $home = $cf{enter_pwd} eq '' ? $cf{homepage} : "$cf{bbs_cgi}?mode=logoff";
	
	# テンプレート読込
	my ($pfile,$cfile,$resloop);
	if (!$in{bbs}) {
		$pfile = 'bbs.html';
		
		open(IN,"$cf{tmpldir}/bbs-res.html") or error("open err: bbs-res.html");
		$resloop = join('',<IN>);
		close(IN);
	} else {
		$pfile = 'topic.html';
	}
	open(IN,"$cf{tmpldir}/$pfile") or error("open err: $pfile");
	my $tmpl = join('',<IN>);
	close(IN);
	
	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );
	} else {
		$tmpl =~ s|<!-- captcha -->.+?<!-- /captcha -->||s;
	}
	
	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!homepage!/$home/g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/<!-- op_icon -->/$op_icon/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon2" />|g;
	$tmpl =~ s/!sub!//g;
	$tmpl =~ s/!reno!//g;
	$tmpl =~ s/!alarm!/$alarm/g;
	$tmpl =~ s/!counter!/$counter/g;
	
	if ($cf{icon_mode} == 0) {
		$tmpl =~ s|<!-- pop_icon -->.+?<!-- /pop_icon -->||s;
	}
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3)
			: error("テンプレート不正");
	
	# ノンアイコン
	if ($cf{icon_mode} == 0) {
		$loop =~ s/!icon!//g;
		$resloop =~ s/!icon!//g;
	}

	# 過去ログ
	if ($cf{pastkey} == 0) {
		$tmpl =~ s|<!-- past -->.+?<!-- /past -->||gs;
	}
	
	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# 記事表示
	foreach (@log) {
		# レス
		my ($res,$n);
		foreach my $r ( split(/,/,$res{$_}) ) {
			$n++;

			if (defined($ext{$r})) {
				$com{$r} = att_file($r,$com{$r},$ext{$r},$imw{$r},$imh{$r},$sub{$r});
			}

			# レス(YouTube)
			if ($cf{tube}) {
				$tube{$r} =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
			}

			my $tmp = $resloop;
			$tmp =~ s/!art-ttl!/$sub{$r}/g;
			$tmp =~ s/!art-name!/$nam{$r}/g;
			$tmp =~ s/!home!/$url{$r}/g;
			$tmp =~ s/!date!/$dat{$r}/g;
			$tmp =~ s/!num!/$r/g;
			$tmp =~ s|!comment!|<span style="color:$col[$col{$r}]">$com{$r}</span>|g;
			$tmp =~ s|!icon!|<img src="$cf{cmnurl}/face/$ico{$r}" class="image" alt="" />|g;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$tmp =~ s/!color2!/$color2{$r}/g;
			$tmp =~ s/<!-- youtube -->/$tube{$r}/ if ($tube{$r});
			$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
			$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=p_form&no=$r"><img src="$cf{cmnurl}/edit.png" title="記事編集" alt="記事編集"></a>|g;
			$res .= $tmp;
		}

		# 親
		if (defined($ext{$_})) {
			$com{$_} = att_file($_,$com{$_},$ext{$_},$imw{$_},$imh{$_},$sub{$_});
		}

		# 親(YouTube)
		if ($cf{tube}) {
			$tube{$_} =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}

		my $tmp = $loop;
		$tmp =~ s/!art-ttl!/$sub{$_}/g;
		$tmp =~ s/!art-name!/$nam{$_}/g;
		$tmp =~ s/!home!/$url{$_}/g;
		$tmp =~ s/!date!/$dat{$_}/g;
		$tmp =~ s/!num!/$_/g;
		$tmp =~ s/!pg!/$in{pg} eq '' ? '0' : $in{pg}/ge;
		$tmp =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
		$tmp =~ s|!comment!|<span style="color:$col[$col{$_}]">$com{$_}</span>|g;
		$tmp =~ s/<!-- res -->/$res/g;
		$tmp =~ s|!icon!|<img src="$cf{cmnurl}/face/$ico{$_}" class="image" alt="" />|g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s/!res!/$rno{$_}/g;
		$tmp =~ s/!update!/$upd{$_}/g;
		$tmp =~ s/!color2!/$color2{$_}/g;
		$tmp =~ s/!ico_fold!/<img src="$cf{ico_fold}" align="top" class="icon2">/g;
		$tmp =~ s/!ico!/&icon($rno{$_},$alarm,$ext{$_},$tube{$_})/eg;
		$tmp =~ s/<!-- youtube -->/$tube{$_}/ if ($tube{$_});
		$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=p_form&no=$_"><img src="$cf{cmnurl}/edit.png" title="記事編集" alt="記事編集" /></a>|g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  フォルダーアイコン
#-----------------------------------------------------------
sub icon {
	my ($res,$alarm,$ext,$tube) = @_;

	# アイコン判断
	my $ico;
	if ($res >= $alarm) { $ico = 'alerm'; }
	elsif ($ext) { $ico = 'image'; }
	elsif ($tube) { $ico = 'tube'; }
	elsif ($res) { $ico = 'resadd'; }
	else { $ico = 1; }

	return qq|<img src="$cf{cmnurl}/$cf{fld_icon}->{$ico}" class="icon2">|;
}

#-----------------------------------------------------------
#  記事閲覧（返信フォーム）
#-----------------------------------------------------------
sub read_log {
	my ($num,$btn) = @_;
	if ($num =~ /^(\d+)$/) { $num = $1; }
	
	my ($resub,@log,%ext,%chk,%imw,%imh);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/);
		
		if ($num == $no || $num == $reno) {
			push(@log,$_);
		}
		if ($num == $no) {
			if ($sub =~ /^Re:/) { $resub = $sub } else { $resub = "Re: $sub"; }
		}
	}
	close(IN);
	
	# クッキー取得
	my @cook = get_cookie($cf{cookie_id});
	$cook[2] ||= 'http://';
	
	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[3] eq "") { $cook[3] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[5] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	# アイコン
	my @icon;
	foreach (@{$cf{icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@icon,$ico);
	}

	# アイコンプルダウン
	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($cook[4] eq $icon[$_]) {
			$op_icon .= qq|<option value="$icon[$_]" selected>$nam\n|;
		} else {
			$op_icon .= qq|<option value="$icon[$_]">$nam\n|;
		}
	}
        #セレクトアイコン
	my ($selecticon,$icon);
        	if ($cook[4] eq '') {
			$selecticon = $icon[0];
        	} else {
			$selecticon = $cook[4];
        	}
	
	# home or logoff
	my $home = $cf{enter_pwd} eq '' ? $cf{homepage} : "$cf{bbs_cgi}?mode=logoff";
	
	# テンプレート読込
	open(IN,"$cf{tmpldir}/read.html") or error("open err: read.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	if ($btn) { $tmpl =~ s|<div id="reg-box" style="display:none;">|<div id="reg-box">|; }
	
	# 画像認証作成
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain,$str_crypt) = cap::make($cf{captcha_key},$cf{cap_len});
	} else {
		$tmpl =~ s|<!-- captcha -->.+?<!-- /captcha -->||s;
	}
	
	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!homepage!/$home/g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!fm-url!/$cook[2]/;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!sub_len!/$cf{sub_len}/;
	$tmpl =~ s/!sub!/$resub/g;
	$tmpl =~ s/!reno!/$num/g;
	$tmpl =~ s/<!-- op_icon -->/$op_icon/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s|<!-- select_icon -->|<img id="imgchange" src="$cf{cmnurl}/face/$selecticon" alt="Selected icon">|g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" class="icon2">|g;
	$tmpl =~ s|<!-- pop_icon -->.+?<!-- /pop_icon -->||s if ($cf{icon_mode} == 0);
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/!pg!/$in{pg} eq '' ? '0' : $in{pg}/ge;
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3)
			: error("テンプレートが不正です");
	
	# ノンアイコン
	$loop =~ s/!icon!//g if ($cf{icon_mode} == 0);
	
	# ヘッダ表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;
	
	# 記事
	foreach (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/);
		$eml &&= qq|<a href="mailto:$eml"><img src="$cf{ico_mail}" class="icon2"></a>| if ($eml);
		$com  = auto_link($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="home" alt="HOME" title="HOME" /></a>|;

		if ($ext) {
			if ($cf{img_check} && $chk eq '0') {
				$ext = "hide";
			}
			$com = att_file2($no,$com,$ext,$w,$h,$sub);
		}

		# YouTube
		if ($cf{tube}) {
			$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!art-ttl!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!art-name!/$name/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s|!icon!|<img src="$cf{cmnurl}/face/$ico" class="image" alt="" />|g;
		$tmp =~ s/!color2!/$color2/g;
		$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
		$tmpl =~ s/!pg!/$in{pg} eq '' ? '0' : $in{pg}/ge;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
		$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=p_form&bbs=$in{bbs}&no=$no"><img src="$cf{cmnurl}/edit.png" alt="記事編集"></a>|g;
		print $tmp;
	}
	
	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  ユーザー登録アイコン・リスト挿入
#-----------------------------------------------------------
sub put_iconlist{

	my @log;
	open(IN,"$cf{iconfile}") or error("open err: $cf{iconfile}");
	while (<IN>) {
		push(@log,$_);
	}
	close(IN);
	foreach (@log) {
		my ($no,$date,$nam,$sub,$eml,$com,$url,$hos,$pw,$ex,$w,$h,$only) = split(/<>/);

		if ($only) { 
			$only = "（$nam 様専用）"; 
		} else { 
			$only = "（共用アイコン）";
		}

		push(@{$cf{icon}},"$no$ex,* $sub $only") if ($cf{user_icon});
	}
}

#-----------------------------------------------------------
#  YouTube貼付方法
#-----------------------------------------------------------
sub expound_page {

	open(IN,"$cf{tmpldir}/expound.html  ") or error("open err: expound.html  ");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  投稿フォーム
#-----------------------------------------------------------
sub form_page {

	# クッキー取得
	my @cook = &get_cookie($cf{cookie_id});
	$cook[2] ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 枠色プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	if ($cook[5] eq "") { $cook[5] = $col3[0]; }
	foreach (0 .. $#col3) {
		if ($cook[5] eq $col3[$_]) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	# ユーザー登録アイコン・ファイルの読み込み/追加
	if ($cf{user_icon} == 1) {
		put_iconlist();
	}

	# アイコン
	my @icon;
	foreach (@{$cf{icon}}) {
		my ($ico,$nam) = split(/,/);
		push(@icon,$ico);
	}

	# アイコンプルダウン
	my $op_icon;
	foreach (0 .. $#{$cf{icon}}) {
		my ($icon,$nam) = split(/,/, $cf{icon}->[$_]);
		if ($cook[4] eq $icon[$_]) {
			$op_icon .= qq|<option value="$icon[$_]" selected>$nam\n|;
		} else {
			$op_icon .= qq|<option value="$icon[$_]">$nam\n|;
		}
	}
        #セレクトアイコン
	my ($selecticon,$icon);
        	if ($cook[4] eq '') {
			$selecticon = $icon[0];
        	} else {
			$selecticon = $cook[4];
        	}

	# 画像認証作成
	my ($str_plain,$str_crypt,$regikey,$JavaScript);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt, $regikey, $JavaScript) = cap::make( $cf{captcha_key}, $cf{cap_len} );
		$JavaScript=&mkJavaScript($regikey,'myFORM') if($cf{cap_len} == 3);
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/!icon_reg!/$cf{icoreg_cgi}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/!sub_len!/$cf{sub_len}/;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/<!-- op_icon -->/$op_icon/g;
	$tmpl =~ s/<!-- op_color2 -->/$color_b/g;
	$tmpl =~ s|<!-- select_icon -->|<img id="imgchange" src="$cf{cmnurl}/face/$selecticon" alt="Selected icon">|g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" class="icon2">|g;
	$tmpl =~ s/!sub!//g;
	if ($cf{icon_mode} == 0) {
	$tmpl =~ s/<!-- pop_icon_begin -->.+<!-- pop_icon_end -->//s;
	}

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  パスワードフォーム
#-----------------------------------------------------------
sub p_form {

	$in{no} =~ s/\D//g;

	# 記事
	my ($name,$pwd);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ext,$w,$h,$chk) = split(/<>/);

	if ($in{no} == $no) {
		$name = $name;
		$pwd = $pw;
		last;
		}
	}
	close(IN);

	# パスワード未設定
	error("この記事はパスワード未設定のため編集できません") if ($pwd eq '');

	my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		$com = auto_link($com) if ($cf{autolink});

		if (length($com) > 135) { $com = substr($com,0,140); $com .= '.....(略)'; }

		# 添付あり
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{upldir}/$no$ex");
			if ($cf{img_check} && $chk != 1) {
				$clip = qq|<div class="clip">[添付]: 認証待ち (<span style="color:#00a1e9">$size</span>)</div>|;
			} else {
				$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> (<span style="color:#00a1e9">$size</span>)</div>|;
			}
		}

	my @col = split(/\s+/, $cf{colors});

	open(IN,"$cf{tmpldir}/p_form.html") or &error("open err: p_form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 文字置換
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
	$tmpl =~ s/<!-- clip -->/$clip/;
	$tmpl =~ s/!color2!/$color2/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" class="icon2">|g;

	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;

	# フッタ
	footer();

	exit;
}

#-----------------------------------------------------------
#  アルバム機能
#-----------------------------------------------------------
sub album {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album.html") or error("open err: album.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# データ読み込み
	my ($i,@img);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = album_pgbtn($i,$pg,'&mode=album',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!page_btn!/$page_btn/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
		s|!mob_css!|$cf{mobcss}|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;

	# 過去ログ
		s/<!-- past -->.+<!-- past -->//s if ($cf{pastkey} == 0);
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$sub,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  アルバム機能 (過去ログ)
#-----------------------------------------------------------
sub album_past {
	# ページ数定義
	my $pg = $in{pg} || 0;

	# 画像サイズ再定義
	$cf{max_img_w} = $cf{alb_img_w};
	$cf{max_img_h} = $cf{alb_img_h};

	# テンプレート認識
	open(IN,"$cf{tmpldir}/album_past.html") or error("open err: album_past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot) = split(/<!-- loop -->/,$tmpl);

	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);

	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# データ読み込み
	my ($i,@img);
	open(IN,"$file") or error("open err: $file");
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ex,$w,$h,$chk) = split(/<>/);
		next if ($cf{imgcheck} && $chk eq '0');
		next if ($ex !~ /(jpg|png|gif)$/);

		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{max_albums});

		# 画像データ収集
		push(@img,"$no\t$sub\t$ex\t$w\t$h");
	}
	close(IN);

	# 繰越ボタン
	my $page_btn = make_pgbtn($i,$pg,'&mode=album_past',$cf{max_albums});

	# 文字置換
	for ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!page_btn!/$page_btn/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
		s|!mob_css!|$cf{mobcss}|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
		s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	foreach (@img) {
		my ($no,$sub,$ex,$w,$h) = split(/\t/);

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!image!/image($no,$sub,$ex,$w,$h)/eg;
		$tmp =~ s/!caption!/$sub/g;
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  繰越ボタン作成 (アルバム)
#-----------------------------------------------------------
sub album_pgbtn {
	my ($i,$pg,$stat,$max) = @_;
	$max ||= 5;

	# ページ繰越定義
	my $next = $pg + $max;
	my $back = $pg - $max;

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $max;
			$z -= $max;

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	# 結果を返す
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  画像表示
#-----------------------------------------------------------
sub image {
	my ($no,$sub,$ex,$w,$h) = @_;

	my $image;
	if (-f "$cf{upldir}/$no-s$ex") {
		$image = qq|<img src="$cf{upldir}/$no-s$ex" border="0">|;

	} else {
		($w,$h) = resize($w,$h);
		$image = qq|<img src="$cf{upldir}/$no$ex" width="$w" height="$h" border="0">|;
	}
	return qq|<a href="$cf{upldir}/$no$ex" class="fancybox-buttons" data-fancybox-group="button" title="No.$no &nbsp;&nbsp;( $sub )">$image</a>\n|;
}

#-----------------------------------------------------------
#  ワード検索
#-----------------------------------------------------------
sub find_data {
	# 条件
	$in{cond} =~ s/\D//g;

	# 検索条件プルダウン
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}</option>\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}</option>\n|;
		}
	}

	# 検索実行
	my ($hit,@log) = search($cf{logfile}) if ($in{word} ne '');

	# 文字色
	my @col = split(/\s+/,$cf{colors});
        my @col3 = split(/\s+/, $cf{colors_b});

	# テンプレート
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s/!bbs!/$in{bbs} eq '' ? '0' : $in{bbs}/ge;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/<!-- op_cond -->/$op_cond/;
	$tmpl =~ s/!word!/$in{word}/;
	$tmpl =~ s/!bbs!/$in{bbs} ne '' ? $in{bbs} : '0'/ge;
	
	# 分割
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3)
			: error("テンプレートが不正です");

	# ノンアイコン
	$loop =~ s/!icon!//g if ($cf{icon_mode} == 0);

	# ヘッダ部
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# ループ部
	foreach my $log (@log) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/, $log);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com  = auto_link($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;

		if ($ext) {
			if ($cf{img_check} && $chk eq '0') {
				$ext = "hide";
			}
			$com = att_file2($no,$com,$ext,$w,$h,$sub);
		}

		# YouTube
		if ($cf{tube}) {
			$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}

		my $tmp = $loop;
		$tmp =~ s/!art-ttl!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s|!icon!|<img src="$cf{cmnurl}/face/$ico" class="image" alt="" />|g;
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  検索実行
#-----------------------------------------------------------
sub search {
	my ($file,$list,$stat) = @_;
	
	# キーワードを配列化
	$in{word} =~ s/　/ /g;
	my @wd = split(/\s+/,$in{word});
	
	# UTF-8定義
	my $byte1 = '[\x00-\x7f]';
	my $byte2 = '[\xC0-\xDF][\x80-\xBF]';
	my $byte3 = '[\xE0-\xEF][\x80-\xBF]{2}';
	my $byte4 = '[\xF0-\xF7][\x80-\xBF]{3}';
	
	# 検索処理
	my ($i,@log);
	open(IN,"$file") or error("open err: $file");
	my $top = <IN> if (!$stat);
	while (<IN>) {
		my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/);
		
		my $flg;
		foreach my $wd (@wd) {
			if ("$nam $eml $sub $com $url" =~ /^(?:$byte1|$byte2|$byte3|$byte4)*?\Q$wd\E/i) {
				$flg++;
				if ($in{cond} == 0) { last; }
			} else {
				if ($in{cond} == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);
		
		$i++;
		if ($list > 0) {
			next if ($i < $in{pg} + 1);
			next if ($i > $in{pg} + $list);
		}
		
		push(@log,$_);
	}
	close(IN);
	
	# 検索結果
	return ($i,@log);
}

#-----------------------------------------------------------
#  留意事項表示
#-----------------------------------------------------------
sub note_page {
	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('',<IN>);
	close(IN);
	
	$tmpl =~ s|!bbs_title!|$cf{bbs_title}|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	
	print "Content-type: text/html; charset=utf-8\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  アイコン一覧
#-----------------------------------------------------------
sub icon_page {
	# 画像サイズ再定義
	$cf{max_img_w} = 40;
	$cf{max_img_h} = 40;
	
	# テンプレート認識
	open(IN,"$cf{tmpldir}/icon.html") or error("open err: icon.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	# 文字置換
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!version!/$cf{version}/g;
	
	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- photo_begin -->(.+)<!-- photo_end -->(.+)/s
			? ($1,$2,$3)
			: error("テンプレートが不正です");
	
	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

	# ユーザー登録アイコン・ファイルの読み込み/追加
	put_iconlist();
	
	foreach (0 .. $#{$cf{icon}}) {
		my ($ico,$cap) = split(/,/,$cf{icon}[$_]);
		
		my $tmp = $loop;
		$tmp =~ s|!image!|<img src="$cf{cmnurl}/face/$ico" alt="" />|g;
		$tmp =~ s/!caption!/$cap/g;
		print $tmp;
	}
	
	# フッタ
	print $foot;
	exit;
}

#-----------------------------------------------------------
#  ボーダーカラー・サンプル
#-----------------------------------------------------------
sub border_page {

	# 時間取得
	my ($date,$time) = get_time2();

	# テンプレート認識
	open(IN,"$cf{tmpldir}/border_color.html") or &error("open err: border_color.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# テンプレート分割
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1, $2, $3);
	} else {
		&error("テンプレートが不正です");
	}

	# 文字置換
	foreach ($head, $foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!version!/$cf{version}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
		s|!mob_css!|$cf{mobcss}|g;
		s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	}

	# 画面展開
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;

        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	foreach (0 .. $#col3) {

		my $tmp = $loop;
		$tmp =~ s|!color_b!|<div class="art_border" style="border-color:$col3[$_];"><div class="rectangle_border" style="background:$col3[$_]">$date</div><div class="triangle_border-l" style="border-color: transparent $col3[$_] transparent transparent;"></div><div class="triangle_border-r" style="border-color: $col3[$_] transparent $col3[$_] $col3[$_];"></div><div class="info_border">記事枠SAMPLE</div></div>|g;
		$tmp =~ s/!name!/$col4[$_]/g;
		print $tmp;
	}

	# フッタ
	&footer($foot);
	exit;
}

#-----------------------------------------------------------
#  過去ログ画面
#-----------------------------------------------------------
sub past_log {
	# 過去ログ番号
	open(IN,"$cf{nofile}") or error("open err: $cf{nofile}");
	my $pastnum = <IN>;
	close(IN);
	
	my $pastnum = sprintf("%04d", $pastnum);
	$in{pno} =~ s/\D//g;
	$in{pno} ||= $pastnum;

	# プルダウンタグ作成
	my $op_pno;
	for ( my $i = $pastnum; $i > 0; $i-- ) {
		$i = sprintf("%04d", $i);

		if ($in{pno} == $i) {
			$op_pno .= qq|<option value="$i" selected="selected">$i</option>\n|;
		} else {
			$op_pno .= qq|<option value="$i">$i</option>\n|;
		}
	}

	# ページ数
	my $pg = $in{pg} || 0;

	# 初期化
	my ($hit,$page_btn,$hit,@log,%res);

	# 対象ログ定義
	my $file = "$cf{pastdir}/" . sprintf("%04d", $in{pno}) . ".cgi";

	# ワード検索
	if ($in{find} && $in{word} ne '') {
		# 検索
		($hit,@log) = search($file,$in{list},'past');

		# 結果
		$page_btn = "検索結果：<b>$hit</b>件 &nbsp;&nbsp;" . pgbtn_old($hit,$in{pno},$pg,$in{list},'find');

	# ログ一覧
	} else {
		my $pg_max = $cf{pg_max} * 2;

		# 過去ログオープン
		my $i = 0;
		open(IN,"$file") or error("open err: $file");
		while(<IN>) {
			my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ico,$color2,$ext,$w,$h,$chk,$tube) = split(/<>/);

			++$i if ($reno eq '');
			next if ($i < $pg + 1);
			next if ($i > $pg + $pg_max);

			if ($reno) {
				$res{$reno} .= "$no<>$reno<>$date<>$nam<>$eml<>$sub<>$com<>$url<>$col<>$ico<>$color2<>$ext<>$w<>$h<>$chk<>$tube\0";
				next;
			}
			push(@log,$_);
		}
		close(IN);

		# 繰越ボタン作成
		$page_btn = pgbtn_old($i,$in{pno},$pg,$pg_max);
	}

	# プルダウン作成（検索条件）
	my %op = make_op();

	# テンプレート読み込み
	open(IN,"$cf{tmpldir}/past.html") or error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);
	
	open(IN,"$cf{tmpldir}/res_past1.html") or error("open err: res_past1.html");
	my $restmpl = join('', <IN>);
	close(IN);
	
	# 文字置換
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/yybbs.css|g;
	$tmpl =~ s|!mob_css!|$cf{mobcss}|g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s/!past_num!/$in{pno}/g;
	$tmpl =~ s/!bbs_url!//g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/<!-- op_pno -->/$op_pno/g;
	$tmpl =~ s/<!-- op_(\w+) -->/$op{$1}/g;
	$tmpl =~ s/!word!/$in{word}/g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s/!bbs!/$in{bbs} ne '' ? $in{bbs} : '0'/ge;

	# テンプレート分割
	my ($head,$loop,$foot) = $tmpl =~ m|(.+)<!-- loop -->(.+?)<!-- /loop -->(.+)|s
			? ($1,$2,$3)
			: error("テンプレート不正");

	# ノンアイコン
	$loop =~ s/!icon!//g if ($cf{icon_mode} == 0);

	if ($in{change}) { $in{word} = ''; }

	# 文字色
	my @col = split(/\s+/,$cf{colors});
        my @col3 = split(/\s+/, $cf{colors_b});

	# 画面表示
	print "Content-type: text/html; charset=utf-8\n\n";
	print $head;
	foreach (@log) {
		my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$col,$ico,$color2,$ex,$w,$h,$chk,$tube) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
		$com = auto_link($com) if ($cf{autolink});
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;

		# レス
		my $res;
		foreach my $log ( split(/\0/, $res{$no}) ) {
			my ($no,$reno,$date,$nam,$eml,$sub,$com,$url,$col,$ico,$color2,$ex,$w,$h,$chk,$tube) = split(/<>/, $log);
			$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml);
			$com = auto_link($com) if ($cf{autolink});
			$url &&= qq|<a href="$url" target="_blank"><img src="$cf{cmnurl}/home.png" class="icon" alt="" /></a>|;

			# 添付あり
			my $clip;
			if ($ex) {
				my $size = get_size("$cf{upldir}/$no$ex");
				if ($cf{img_check} && $chk != 1) {
					$clip = qq|<div class="clip">[添付]: 認証待ち (<span style="color:#00a1e9">$size</span>)</div>|;
				} else {
					$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> (<span style="color:#00a1e9">$size</span>)</div>|;
				}
			}

		# YouTube
		if ($cf{tube}) {
			$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}

			my $tmp = $restmpl;
			$tmp =~ s/!art-ttl!/$sub/g;
			$tmp =~ s/!art-name!/$nam/g;
			$tmp =~ s/!date!/$date/g;
			$tmp =~ s/!home!/$url/g;
			$tmp =~ s/!mail!/$eml/g;
			$tmp =~ s/!num!/$no/g;
			$tmp =~ s/!url!/$url/g;
			$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
			$tmp =~ s|!icon!|<img src="$cf{cmnurl}/face/$ico" class="image" alt="" />|g;
			$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
			$tmp =~ s/!color2!/$color2/g;
			$tmp =~ s/<!-- clip -->/$clip/;
			$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
			$res .= $tmp;
		}

			# 添付あり
			my $clip;
			if ($ex) {
				my $size = get_size("$cf{upldir}/$no$ex");
				if ($cf{imgcheck} && $chk != 1) {
					$clip = qq|<div class="clip">[添付]: 認証待ち (<span style="color:#00a1e9">$size</span>)</div>|;
				} else {
					$clip = qq|<div class="clip">[添付]: <a href="$cf{uplurl}/$no$ex" target="_blank">$no$ex</a> (<span style="color:#00a1e9">$size</span>)</div>|;
				}
			}

		# YouTube
		if ($cf{tube}) {
			$tube =~ s|!([\w\-]{1,})!|<div class="imageCover"><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="https://i.ytimg.com/vi/$1/mqdefault.jpg" width="240" height="154" class="baseImage"></a><a class="fancybox-media" href="http://www.youtube.com/watch?v=$1" title="Youtube"><img src="$cf{tube_ico}" width="64" height="64" class="coverImage"></a></div>|g;
		}

		my $tmp = $loop;
		$tmp =~ s/!art-ttl!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!mail!/$eml/g;
		$tmp =~ s/!url!/$url/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s|!icon!|<img src="$cf{cmnurl}/face/$ico" class="image" alt="" />|g;
		$tmp =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/<!-- res -->/<blockquote>$res<\/blockquote>/g if ($res);
		$tmp =~ s/!color2!/$color2/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		$tmp =~ s/<!-- youtube -->/$tube/ if ($tube);
		print $tmp;
	}

	# フッタ
	footer($foot);
}

#-----------------------------------------------------------
#  枠サンプル用時間取得
#-----------------------------------------------------------
sub get_time2 {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 日時のフォーマット
	my $date = sprintf("%04d/%02d/%02d(%s)",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  URLエンコード
#-----------------------------------------------------------
sub url_enc {
	local($_) = @_;

	s/(\W)/'%' . unpack('H2', $1)/eg;
	s/\s/+/g;
	$_;
}

#-----------------------------------------------------------
#  繰越ボタン作成 [ 過去ログ ]
#-----------------------------------------------------------
sub pgbtn_old {
	my ($i,$pno,$pg,$list,$stat) = @_;

	# ページ繰越定義
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	my $link;
	if ($stat eq 'past') {
		my $wd = url_enc($in{word});
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno&amp;find=1&amp;word=$wd&amp;list=$list";
	} else {
		$link = "$cf{bbs_cgi}?mode=$in{mode}&amp;pno=$pno";
	}

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>\n!);
			} else {
				push(@pg,qq!<li><a href="$link&amp;pg=$y">$x</a></li>\n!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};
			
			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$link&amp;pg=$back">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$link&amp;pg=$next">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">\n$ret</ul>| : '';
}

#-----------------------------------------------------------
#  プルダウン作成 [ 検索条件 ]
#-----------------------------------------------------------
sub make_op {
	my %op;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op{cond} .= qq|<option value="$_" selected="selected">$cond{$_}</option>\n|;
		} else {
			$op{cond} .= qq|<option value="$_">$cond{$_}</option>\n|;
		}
	}
	for ( my $i = 10; $i <= 30; $i += 5 ) {
		if ($in{list} == $i) {
			$op{list} .= qq|<option value="$i" selected="selected">$i件</option>\n|;
		} else {
			$op{list} .= qq|<option value="$i">$i件</option>\n|;
		}
	}
	return %op;
}

#-----------------------------------------------------------
#  カウンタ処理
#-----------------------------------------------------------
sub bbs_count {
	# IP取得
	my $addr = $ENV{REMOTE_ADDR};

	# 閲覧時のみカウントアップ
	my $cntup = $in{mode} eq '' ? 1 : 0;

	# カウントファイルを読みこみ
	open(LOG,"+< $cf{cntfile}") or error("open err: $cf{cntfile}");
	eval "flock(LOG, 2);";
	my $count = <LOG>;

	# IPチェックとログ破損チェック
	my ($cnt,$ip) = split(/:/,$count);
	if ($addr eq $ip or $cnt eq "") { $cntup = 0; }

	# カウントアップ
	if ($cntup) {
		$cnt++;
		seek(LOG, 0, 0);
		print LOG "$cnt:$addr";
		truncate(LOG, tell(LOG));
	}
	close(LOG);

	# 桁数調整
	while(length($cnt) < $cf{mini_fig}) { $cnt = '0' . $cnt; }
	my @cnts = split(//,$cnt);

	# GIFカウンタ表示
	my $counter;
	if ($cf{counter} == 2) {
		foreach (0 .. $#cnts) {
			$counter .= qq|<img src="$cf{gif_path}/$cnts[$_].gif\" alt="$cnts[$_]" />|;
		}

	# テキストカウンタ表示
	} else {
		$counter = qq|<span style="color:$cf{cntcol}">$cnt</span>\n|;
	}
	return $counter;
}

#-----------------------------------------------------------
#  自動リンク
#-----------------------------------------------------------
sub auto_link {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  著作権表記（削除・改変を禁ず）
#-----------------------------------------------------------
sub footer {
	my ($foot) = @_;
	
	my $copy = <<EOM;
<p style="margin-top:3em;text-align:center;font-family:メイリオ,Meiryo,ＭＳ Ｐゴシック,Verdana,Helvetica,Arial;font-size:11pt;">
	<div style="text-align:center;">- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
	++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++<br>
    Adapted by Sennin @<a href="http://www.senninnosato.net/" target="_blank">仙人の里</a></div>
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  繰越ボタン作成
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg,$stat) = @_;

	# ページ繰越定義
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# ページ繰越ボタン作成
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y$stat">$x</a></li>!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back$stat">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next$stat">&raquo;</a></li>\n!;
	}
	
	# 結果を返す
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  クッキー取得
#-----------------------------------------------------------
sub get_cookie {
	my $cook_id = shift;

	# クッキー取得
	my $cook = $ENV{HTTP_COOKIE};

	# 該当IDを取り出す
	my %cook;
	foreach ( split(/;/,$cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLデコード
	my @cook;
	foreach ( split(/<>/,$cook{$cook_id}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  クッキー発行
#-----------------------------------------------------------
sub set_cookie {
	my $cook_id = shift;
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# 時刻フォーマット
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLエンコード
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cook_id=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  ファイル容量
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  桁区切り
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  添付リンク
#-----------------------------------------------------------
sub att_file {
	my ($no,$com,$ex,$w,$h,$sub) = @_;

	# 未公開
	if ($ex eq 'hide') {
		$com .= qq|<p>[添付]: 認証待ち</p>|;

	# 画像のとき
	} elsif ($ex =~ /(jpg|png|gif)$/) {

		my $op;
		if (-f "$cf{upldir}/$no-s$ex") {
			$op = qq|src="$cf{uplurl}/$no-s$ex"|;
		} else {
			($w,$h) = resize($w,$h);
			$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
		}

		# 画像はコメントの下
		if ($cf{image_position} == 1) {
			$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="fancybox-effects-c" title="No.$no &nbsp;&nbsp;( $sub )"><img $op border="0" class="snapshot"></a></p>|;
		# 画像はコメントの右（廻り込み）
		} else {
			$com = qq|<div class="ext"><a href="$cf{uplurl}/$no$ex" class="fancybox-effects-c" title="No.$no&nbsp; ( $sub )"><img $op border="0" class="ext2a"></a></div>$com<br clear="all">|;
		}

	# 画像以外のとき
	} else {
		my $size = get_size("$cf{upldir}/$no$ex");
		$com .= qq|<p>添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> (<b style="color:#00a1e9">$size</b>)</p>|;
	}

	return $com;
}

#-----------------------------------------------------------
#  添付リンク
#-----------------------------------------------------------
sub att_file2 {
	my ($no,$com,$ex,$w,$h,$sub) = @_;

	# 未公開
	if ($ex eq 'hide') {
		$com .= qq|<p>[添付]: 認証待ち</p>|;

	# 画像のとき
	} elsif ($ex =~ /(jpg|png|gif)$/) {

		my $op;
		if (-f "$cf{upldir}/$no-s$ex") {
			$op = qq|src="$cf{uplurl}/$no-s$ex"|;
		} else {
			($w,$h) = resize($w,$h);
			$op = qq|src="$cf{uplurl}/$no$ex" width="$w" height="$h"|;
		}

		# 画像はコメントの下
		if ($cf{image_position} == 1) {
			$com .= qq|<p><a href="$cf{uplurl}/$no$ex" class="fancybox-effects-c" title="No.$no &nbsp;&nbsp;( $sub )"><img $op border="0"></a></p>|;
		# 画像はコメントの右（廻り込み）
		} else {
			$com = qq|<a href="$cf{uplurl}/$no$ex" class="fancybox-effects-c" title="No.$no &nbsp;&nbsp;( $sub )"><div class="ext2"><img $op border="0" class="ext2a"></div></a>$com<br clear="all">|;
		}

	# 画像以外のとき
	} else {
		my $size = get_size("$cf{upldir}/$no$ex");
		$com .= qq|<p>添付: <a href="$cf{uplurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> (<b style="color:#00a1e9">$size</b>)</p>|;
	}

	return $com;
}

#-----------------------------------------------------------
#  取り扱いファイル
#-----------------------------------------------------------
sub ext_file {
	my $ext;
	foreach ( keys %cf ) {
		next if ($_ !~ /^ok_(\w+)/);
		my $file = $1;
		next if (!$cf{$_});

		$file =~ tr/a-z/A-Z/;
		$ext .= "$file, ";
	}
	$ext =~ s/, $//;

	return $ext;
}

